/* 
 * File:   colorReduce.cpp
 * Author: gb
 *
 * Created on 4 de Novembro de 2015, 14:23
 */

#include <cstdlib>
#include "opencv2/opencv.hpp"

using namespace cv;

void colorReduce(Mat &image, float div=8) {
        float fator = div/256;
        float inverso = 256/div;
        
        int nl= image.rows; //captura qtd linhas
        //usa as colunas de maneira linear multiplicando pela quantidade de canais 
        int nc= image.cols * image.channels();  
        //para cada linha
        for (int j=0; j<nl; j++) {  

            //obtem o endereço de uma linha. Vira um vetor!!!
            uchar* data= image.ptr<uchar>(j);
            for (int i=0; i<nc; i++) {
                data[i]= data[i] * fator;
                data[i]= data[i] * inverso; //ajuste para apresentação apenas
                                            //pode comentar se não for apresentar!
            }
        }
}


int main(int, char**)
{
    VideoCapture cap(0); //abre a camera padrão. Estou num notebook!
    if(!cap.isOpened())  //checa se funcionou
        return -1;

    namedWindow("Color Reduce",1);  //define uma janela de apresentação
    for(;;)  //define um laço infinito para pegar vários frames
    {
        Mat frame;    
        cap >> frame; //obtem um novo frame a partir da camera
        
        colorReduce(frame,32);
        /*exibe o frame processado. Verifique que o primeiro
        parâmetro é equivalente ao nome da janela criada */
        imshow("Color Reduce", frame);  
        
        if(waitKey(30) >= 0) break;
    }
    return 0;
}
